#alias:new clean_known_hosts e:cat
fn clean_known_hosts [@_args]{
  use str
  use moi/util/condition
  use moi/util/list
  use moi/util/ip
  fn less [cmp e1 e2]{ < ($cmp $e1 $e2) 0 }
  fn sort-host [e1 e2]{
    local:i1 = (condition:set (ip:is-ip $e1) 1 0)
    local:i2 = (condition:set (ip:is-ip $e2) 1 0)
    if (!= $i1 $i2) {
      < $i1 $i2
    } elif (== $i1 0) {
      <s $e1 $e2
    } else {
      less $ip:cmp~ $e1 $e2
    }
  }

  local:khosts = [&]
  cat ~/.ssh/known_hosts | eawk [_ hosts @rest]{
    local:key = (str:join ' ' $rest)
    if (not (has-key $khosts $key)) {
      khosts[$key] = [&]
    }
    str:split , $hosts | each [h]{
      khosts[$key][$h] = $nil
    }
  }
  
  local:lines = [(keys $khosts | each [key]{
    local:hosts = (keys $khosts[$key] | order &less-than=$sort-host~ | str:join ,)
    put $hosts $key | str:join ' '
  })]
  echo (str:join "\n" $lines) > ~/.ssh/known_hosts
}
